unit detect;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls;

type
  TFDetect = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Edit3: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FDetect: TFDetect;

implementation

uses
  fonctions, rapport, main;

{$R *.xfm}

procedure TFDetect.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TFDetect.Button1Click(Sender: TObject);
var
  N, N_poly, Npoints: Integer;
  i: Integer;
  poly: Polygone;
begin
  { tester les polys }
  if (ImageG.Polygones.Count = 0) then begin
    MessageDlg('Au moins un polygone dans l''image gauche est ncessaire pour cette tape.', mtError, [mbOK], 0);
    Exit;
  end;
  if (not CheckPolys(ImageG.Polygones)) then begin
    MessageDlg('Au moins un polygone de l''image gauche n''est pas ferm.', mtError, [mbOK], 0);
    Exit;
  end;

  { tester les valeurs entrees }
  try
    N_poly:= StrToInt(Edit3.Text);
  except
    MessageDlg('La taille de la fentre d''inclusion n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    N:= StrToInt(Edit1.Text);
  except
    MessageDlg('La taille du filtre dtecteur n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    Npoints:= StrToInt(Edit2.Text);
  except
    MessageDlg('Le nombre de points n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;

  FRapport.Show;
  FRapport.Write('====================================================');
  FRapport.Write('============ Dtection de points d''intrt   ============');
  FRapport.Write('====================================================');
  FRapport.Write('  Nombre de points par polygone : '+Edit2.Text);
  FRapport.Write('  Taille du filtre : '+Edit1.Text+'x'+Edit1.Text);
  FRapport.Write('  Taille de la fentre d''inclusion dans le polygone : '+Edit3.Text+'x'+Edit3.Text);
  FRapport.Write('');
  DetectPts(ImageG.Polygones, ImageG.TheImage, N, N_poly, Npoints);

  PtsIntDrawable:= true;
  PtsIntAppDrawable:= false;
  PtsIntAppRobDrawable:= false;
  ImageG.PaintBuffer;
  ImageG.RefreshBox;

  for i:= 0 to ImageG.Polygones.Count-1 do begin
    poly:= Polygone(ImageG.Polygones[i]);
    if (poly.Locked) then Continue;
    FRapport.Write('  --> Polygone '+IntToStr(i+1)+'/'+IntToStr(ImageG.Polygones.Count)+': '+IntToStr(PtsIndex[i])+' points');
  end;
  FRapport.Write(' ');
  FRapport.Write(' ');
  
  Close;
end;

end.
