unit disparites;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls;

type
  TFDisparites = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    RadioGroup1: TRadioGroup;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FDisparites: TFDisparites;

implementation

uses rapport, fonctions, main;

{$R *.xfm}

procedure TFDisparites.Button1Click(Sender: TObject);
var
  Facteur, mult, prec: Integer;
  s: string;
begin
  { tester les pts d'intrt }
  if (Length(Hom) = 0) then begin
    MessageDlg('Le calcul des homographies est ncessaire pour cette tape.', mtError, [mbOK], 0);
    Exit;
  end;

  { tester les valeurs entrees }
  try
    Facteur:= StrToInt(Edit1.Text);
  except
    MessageDlg('Le facteur de rsolution n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    prec:= StrToInt(Edit2.Text);
  except
    MessageDlg('Le coefficient multiplicatif RVB n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    mult:= StrToInt(Edit3.Text);
  except
    MessageDlg('Le coefficient multiplicatif niveaux de gris n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;


  FRapport.Show;
  FRapport.Write('====================================================');
  FRapport.Write('=========== Calcul des disparits ==============');
  FRapport.Write('====================================================');
  FRapport.Write('  Facteur de rsolution des calculs : '+Edit1.Text);

  FRapport.Write('  Coefficient multiplicatif RVB : '+Edit2.Text);

  FRapport.Write('  Coefficient multiplicatif niveaux de gris : '+Edit3.Text);

  s:= '  Homographie choisie : ';

  if (RadioGroup1.ItemIndex = 0) then

    s:= s + 'estimation linaire'

  else if (RadioGroup1.ItemIndex = 1) then

    s:= s + 'estimation non linaire'

  else if (RadioGroup1.ItemIndex = 2) then

    s:= s + 'estimation robuste'

  else if (RadioGroup1.ItemIndex = 3) then

    s:= s + 'estimation robuste non linaire';

  FRapport.Write(s);

  FRapport.Write('');

  CalcDisp(Facteur, mult, prec, RadioGroup1.ItemIndex);

  //MessageDlg('Le calcul des disparits est termine.', mtInformation, [mbOK], 0);
  Close;
end;

procedure TFDisparites.Button2Click(Sender: TObject);
begin
  Close;
end;

end.
