unit main;

interface

uses
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QMenus, QTypes, image, QExtCtrls, Inifiles, QComCtrls,
  QImgList, QButtons, fonctions, QWinCursors;

type
  TFMain = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Nouveauprojet1: TMenuItem;
    Ouvrirprojet1: TMenuItem;
    Fermerprojet1: TMenuItem;
    N1: TMenuItem;
    Quitter1: TMenuItem;
    Affichage1: TMenuItem;
    Imagegauche1: TMenuItem;
    Imagedroite1: TMenuItem;
    Outils1: TMenuItem;
    Aide1: TMenuItem;
    Apropos1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    SpeedButtonArrow: TSpeedButton;
    SpeedButtonAdd: TSpeedButton;
    SpeedButtonMove: TSpeedButton;
    SpeedButtonDel: TSpeedButton;
    Memo1: TMemo;
    Optimiserlasegmentation1: TMenuItem;
    Chercherlespointsdintrt1: TMenuItem;
    Apparierlespointsdintrt1: TMenuItem;
    Calculerlacartedesdisparits1: TMenuItem;
    Rapport1: TMenuItem;
    Panel2: TPanel;
    LabelUV: TLabel;
    Edition1: TMenuItem;
    Rinitialiserlessommetsdelimagegauche1: TMenuItem;
    Rinitialiserlessommetsdelimagedroite1: TMenuItem;
    Estimerleshomographies1: TMenuItem;
    N2: TMenuItem;
    Aide2: TMenuItem;
    N3: TMenuItem;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Ajusterlessommetsdevantappartenirunct1: TMenuItem;
    procedure Quitter1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
    procedure Nouveauprojet1Click(Sender: TObject);
    procedure Imagegauche1Click(Sender: TObject);
    procedure Imagedroite1Click(Sender: TObject);
    procedure Fermerprojet1Click(Sender: TObject);
    procedure Ouvrirprojet1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Optimiserlasegmentation1Click(Sender: TObject);
    procedure Rapport1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Chercherlespointsdintrt1Click(Sender: TObject);
    procedure SpeedButtonAddClick(Sender: TObject);
    procedure SpeedButtonArrowClick(Sender: TObject);
    procedure SpeedButtonMoveClick(Sender: TObject);
    procedure SpeedButtonDelClick(Sender: TObject);
    procedure Rinitialiserlessommetsdelimagegauche1Click(Sender: TObject);
    procedure Rinitialiserlessommetsdelimagedroite1Click(Sender: TObject);
    procedure Apparierlespointsdintrt1Click(Sender: TObject);
    procedure Estimerleshomographies1Click(Sender: TObject);
    procedure Calculerlacartedesdisparits1Click(Sender: TObject);
    procedure Aide2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Ajusterlessommetsdevantappartenirunct1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
    ProjectLocation: string;
    procedure SaveProject;
    procedure SaveProjectLocation(location: string);
    function LoadProject(location: string): Boolean;
    procedure FreeProject;
    function CheckCurrentProject: Boolean;
  public
    { Public declarations }
    ActiveImage: TFImage;
    procedure DebloqueItems;
    procedure BloqueItems;
    function NewProject: Boolean;
    procedure PolygonesToMemo;
  end;

var
  FMain: TFMain;
  IsProject: Boolean;
  LastDir: string;
  ImageG, ImageD: TFImage;
  NCol, Nlig, NCol2, NLig2: Integer;
  ImGradXg, ImGradYg, ImGradXd, ImGradYd: pMatInt;
  PolyMapG, polyMapD: TBitmap;
  PtsInt: array of array of TRPoint;
  PtsIndex: array of Integer;
  PtsIntApp: array of array of TRPoint;
  PtsIndexApp: array of Integer;
  PtsIntAppRob: array of array of TRPoint;
  PtsIntDrawable, PtsIntAppDrawable, PtsIntAppRobDrawable: Boolean;
  Hom: array of array[0..2,0..2] of Real;
  HomN: array of array[0..2,0..2] of Real;
  HomR: array of array[0..2,0..2] of Real;
  HomRN: array of array[0..2,0..2] of Real;
  Obj: array of array[0..7] of Real;
  Mode: Integer;
  Xs, Ys: Integer;
  Uz, Vz: Real;
  KK: Integer;
  PolyMap: array of array of Integer;
  Sommets_ajust: array[0..3] of Sommet;

const
  crSomCur = 25;

implementation

uses about, new, opti, rapport, detect, appariement, estime,
  disparites, aide;

{$R *.xfm}

procedure TFMain.PolygonesToMemo;
var
  i, j: Integer;
  poly: Polygone;
  s: string;
begin
  Memo1.Clear;
  Memo1.Lines.Add('Image gauche :');
  for i:= 0 to ImageG.Polygones.Count-1 do begin
    poly:= Polygone(ImageG.Polygones[i]);
    s:= '    '+IntToStr(i+1)+' (';
    if (poly.Locked) then
      s:= s + 'bloqu) : '
    else
      s:= s + 'libre) : ';
    Memo1.Lines.Add(s);
    s:= '';
    for j:= 0 to poly.Sommets.Count-1 do begin
      s:= s + '('+Format('%5.1f', [Sommet(poly.Sommets[j]).U]) + ' ' + Format('%5.1f', [Sommet(poly.Sommets[j]).V]) + ') ';
    end;
    Memo1.Lines.Add(s);
  end;
  Memo1.Lines.Add(' ');
  Memo1.Lines.Add('Image droite :');
  for i:= 0 to ImageD.Polygones.Count-1 do begin
    poly:= Polygone(ImageD.Polygones[i]);
    s:= '    '+IntToStr(i+1)+' (';
    if (poly.Locked) then
      s:= s + 'bloqu) : '
    else
      s:= s + 'libre) : ';
    Memo1.Lines.Add(s);
    s:= '';
    for j:= 0 to poly.Sommets.Count-1 do begin
      s:= s + '('+Format('%5.1f', [Sommet(poly.Sommets[j]).U]) + ' ' + Format('%5.1f', [Sommet(poly.Sommets[j]).V]) + ') ';
    end;
    Memo1.Lines.Add(s);
  end;
end;

procedure TFMain.Quitter1Click(Sender: TObject);
begin
  if (CheckCurrentProject) then Close;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
  IsProject:= false;
  ProjectLocation:= '';
  LastDir:= '';
  PtsIntDrawable:= false;
  PtsIntAppDrawable:= false;
  PtsIntAppRobDrawable:= false;
  ActiveImage:= nil;
  ImGradXg:= nil;
  ImGradYg:= nil;
  ImGradXd:= nil;
  ImGradYd:= nil;
  PolyMapG:= nil;
  PolyMapD:= nil;
  Mode:= 0;
  Uz:= -1;
  Vz:= -1;
//  Screen.Cursors[crSomCur] := LoadCursor(HInstance, 'SOMCUR');
end;

procedure TFMain.Apropos1Click(Sender: TObject);
begin
  FAbout.Show;
end;

procedure TFMain.Nouveauprojet1Click(Sender: TObject);
begin
  if (CheckCurrentProject) then FNew.Show;
end;

procedure TFMain.DebloqueItems;
begin
  FermerProjet1.Enabled:= true;
  ImageGauche1.Enabled:= true;
  ImageDroite1.Enabled:= true;
  Rapport1.Enabled:= true;
  Outils1.Enabled:= true;
end;

procedure TFMain.BloqueItems;
begin
  FermerProjet1.Enabled:= false;
  ImageGauche1.Enabled:= false;
  ImageDroite1.Enabled:= false;
  Rapport1.Enabled:= false;
  Outils1.Enabled:= false;
end;

procedure TFMain.Imagegauche1Click(Sender: TObject);
begin
  ImageG.Show;
end;

procedure TFMain.Imagedroite1Click(Sender: TObject);
begin
  ImageD.Show;
end;

procedure TFMain.Fermerprojet1Click(Sender: TObject);
begin
  { si projet pas encore sauv alors on demande un path }
  if (ProjectLocation = '') then begin
    SaveProject;
  end
  else begin
    SaveProjectLocation(Projectlocation);
  end;
end;

procedure TFMain.SaveProject;
var
  Save: Boolean;
begin
  Save:= true;
  SaveDialog1:= TSaveDialog.Create(Self);
  try
    {$IFDEF LINUX}
    SaveDialog1.Filter := 'Projet obtention vrit terrain(*.ovt)|*.ovt';
    {$ENDIF}
    {$IFDEF MSWINDOWS}
    SaveDialog1.Filter := 'Projet obtention vrit terrain(*.ovt)';
    {$ENDIF}
    SaveDialog1.Title:= 'Sauvegarde du projet en cours';
    SaveDialog1.InitialDir:= LastDir;
    SaveDialog1.FileName:= FNew.EditNom.Text + '.ovt';
    if (SaveDialog1.Execute) Then begin
      ProjectLocation:= SaveDialog1.FileName;
      // check si le fichier existe
      if (FileExists(ProjectLocation)) then begin
        if (MessageDlg('Ce fichier de projet existe dj. Voulez-vous le remplacer ?', mtWarning, [mbYes, mbNo], 0) = mrNo) then Save:= false;
      end;
      if (Save) then begin
        if (pos('.ovt',ProjectLocation) = 0) Then ProjectLocation:= ProjectLocation + '.ovt';
        LastDir:= ExtractFileDir(SaveDialog1.FileName);
        SaveProjectLocation(ProjectLocation);
      end
      else ProjectLocation:= '';
    end;
  finally
    SaveDialog1.Free;
  end;
end;

procedure TFMain.SaveProjectLocation(location: string);
var
  ini: TIniFile;
  i, j, k, index: Integer;
  poly: Polygone;
  som: Sommet;
  s, sp: string;
  Image: TFImage;
begin
  DeleteFile(location);
  ini:= TIniFile.Create(location);
  try
    // sauvegarde des infos gnrales
    ini.WriteString('general', 'nom_projet', FNew.EditNom.Text);
    ini.WriteString('general', 'imageg_location', FNew.EditGauche.Text);
    ini.WriteString('general', 'imaged_location', FNew.EditDroite.Text);
    ini.WriteInteger('polygones', 'nbre_gauche', ImageG.Polygones.Count);
    ini.WriteInteger('polygones', 'nbre_droite', ImageD.Polygones.Count);

    for k:= 1 to 2 do begin
      index:= 0;
      if (k = 1) then begin
        sp:= 'gauche';
        Image:= ImageG;
      end
      else begin
        sp:= 'droite';
        Image:= ImageD;
      end;

      { remise  -1 des index }
      for i:= 0 to Image.Polygones.Count-1 do begin
        poly:= Polygone(Image.Polygones[i]);
        for j:= 0 to poly.Sommets.Count-1 do begin
          Sommet(poly.Sommets[j]).index:= -1;
        end;
      end;

      for i:= 0 to Image.Polygones.Count-1 do begin
        poly:= Polygone(Image.Polygones[i]);
        s:= 'p'+IntToStr(i+1);
        ini.WriteInteger(sp, s+'.nbre_sommets', poly.Sommets.Count);
        for j:= 0 to poly.Sommets.Count-1 do begin
          som:= Sommet(poly.Sommets[j]);
          if (som.index = -1) then begin
            ini.WriteFloat('sommets_'+sp, IntToStr(index)+'.U', som.U);
            ini.WriteFloat('sommets_'+sp, IntToStr(index)+'.V', som.V);
            ini.WriteBool('sommets_'+sp, IntToStr(index)+'.BordU', som.BordU);
            ini.WriteBool('sommets_'+sp, IntToStr(index)+'.BordV', som.BordV);
            som.index:= index;
            Inc(index);
          end;
          ini.WriteInteger(sp, s+'-'+IntToStr(j+1)+'.index', som.index);
        end;
      end;
      ini.WriteInteger('sommets', 'nbre_'+sp, index);
    end;
  finally
    Ini.Free;
  end;
end;

procedure TFMain.Ouvrirprojet1Click(Sender: TObject);
begin
  if (not CheckCurrentProject) then Exit;
  OpenDialog1:= TOpenDialog.Create(Self);
  try
    {$IFDEF LINUX}
    OpenDialog1.Filter:= 'Projet obtention vrit terrain(*.ovt)|*.ovt';
    {$ENDIF}
    {$IFDEF MSWINDOWS}
    OpenDialog1.Filter:= 'Projet obtention vrit terrain(*.ovt)';
    {$ENDIF}
    OpenDialog1.Title:= 'Ouverture de projet';
    OpenDialog1.InitialDir:= LastDir;
    if (OpenDialog1.Execute) Then begin
      ProjectLocation:= OpenDialog1.FileName;
      LastDir:= ExtractFileDir(OpenDialog1.FileName);
      try
        if (LoadProject(ProjectLocation)) then begin;
          ProjectLocation:= OpenDialog1.FileName;
          DebloqueItems;
          IsProject:= true;
        end
        else begin
          ProjectLocation:= '';
        end;
      except
      end;
    end;
  finally
    OpenDialog1.Free;
  end;
end;

function TFMain.LoadProject(location: string): Boolean;
var
  ini: TIniFile;
  i, j, np, n, k: Integer;
  Image: TFImage;
  poly: Polygone;
  s, sp: string;
  soms: array of Sommet;
begin
  Result:= true;
  ini:= TIniFile.Create(location);
  try
    FNew.EditNom.Text:= ini.ReadString('general', 'nom_projet', 'sans nom');
    FNew.EditGauche.Text:= ini.ReadString('general', 'imageg_location', '');
    FNew.EditDroite.Text:= ini.ReadString('general', 'imaged_location', '');
    try
      Result:= NewProject;
      for k:= 1 to 2 do begin
        if (k = 1) then begin
          np:= ini.ReadInteger('polygones', 'nbre_gauche', 0);
          Image:= ImageG;
          sp:= 'gauche';
        end
        else begin
          np:= ini.ReadInteger('polygones', 'nbre_droite', 0);
          Image:= ImageD;
          sp:= 'droite';
        end;
        { crer les sommets }
        SetLength(soms, ini.ReadInteger('sommets', 'nbre_'+sp, 0));
        for i:= 0 to Length(soms)-1 do begin
          soms[i]:= Sommet.Create;
          soms[i].U:= ini.ReadFloat('sommets_'+sp, IntToStr(i)+'.U', 0);
          soms[i].V:= ini.ReadFloat('sommets_'+sp, IntToStr(i)+'.V', 0);
          soms[i].BordU:= ini.ReadBool('sommets_'+sp, IntToStr(i)+'.BordU', false);
          soms[i].BordV:= ini.ReadBool('sommets_'+sp, IntToStr(i)+'.BordV', false);
        end;

        for i:= 0 to np-1 do begin
          poly:= Polygone.Create;
          s:= 'p'+IntToStr(i+1);
          n:= ini.ReadInteger(sp, s+'.nbre_sommets', 0);
          for j:= 0 to n-1 do begin
            poly.Sommets.Add(soms[ini.ReadInteger(sp, s+'-'+IntToStr(j+1)+'.index', 0)]);
          end;
          Image.Polygones.Add(poly);
        end;
        PolygonesToMemo;
        Image.PaintBuffer;
        Image.RefreshBox;
      end
    except
    end;
  finally
    ini.Free;
  end;
end;

procedure TFMain.FreeProject;
begin
  BloqueItems;
  SpeedButtonArrow.Down:= true;
  SpeedButtonArrowClick(nil);
  ImageG.Free;
  ImageD.Free;
  try
  if (ImGradXg <> nil) then begin
    Dispose(ImGradXg);
    ImGradXg:= nil;
  end;
  if (ImGradYg <> nil) then begin
    Dispose(ImGradYg);
    ImGradYg:= nil;
  end;
  if (ImGradXd <> nil) then begin
    Dispose(ImGradXd);
    ImGradXd:= nil;
  end;
  if (ImGradYd <> nil) then begin
    Dispose(ImGradYd);
    ImGradYd:= nil;
  end;
  if (PolyMapG <> nil) then begin
    PolyMapG.Free;
    PolyMapG:= nil;
  end;
  if (PolyMapD <> nil) then begin
    PolyMapD.Free;
    PolyMapD:= nil;
  end;
  except
  end;
  IsProject:= false;
  ProjectLocation:= '';
  PtsIntDrawable:= false;
  PtsIntAppDrawable:= false;
  PtsIntAppRobDrawable:= false;
  Caption:= 'OVT';
  PtsInt:= nil;
  PtsIntApp:= nil;
  Hom:= nil;
  HomN:= nil;
  PtsIndex:= nil;
  PtsIndexApp:= nil;
end;

function TFMain.NewProject: Boolean;
begin
  { cration des fentres et chargements des images
  si une image n'est pas bonne on devra tout refermer }
  Application.CreateForm(TFImage, ImageG);
  Result:= ImageG.Loadmage(FNew.EditGauche.Text, 'gauche', ExtractFileName(FNew.EditGauche.Text));
  if (not Result) then begin
    MessageDlg('Erreur lors du chargement de l''image gauche ! Cration du projet impossible.', mtError, [mbOK], 0);
    ImageG.Close;
    ImageG.Free;
    Exit;
  end;
  if (ImageG.TheImage.PixelFormat <> pf8bit) then begin
    MessageDlg('L''image gauche n''est pas compose de pixels cods sur 8 bits ! Cration du projet impossible.', mtError, [mbOK], 0);
    ImageG.Close;
    ImageG.Free;
    Result:= false;
    Exit;
  end;
  Application.CreateForm(TFImage, ImageD);
  Result:= ImageD.Loadmage(FNew.EditDroite.Text, 'droite', ExtractFileName(FNew.EditDroite.Text));
  if (not Result) then begin
    MessageDlg('Erreur lors du chargement de l''image droite ! Cration du projet impossible.', mtError, [mbOK], 0);
    ImageG.Close;
    ImageG.Free;
    ImageD.Close;
    ImageD.Free;
    Exit;
  end;
  if (ImageD.TheImage.PixelFormat <> pf8bit) then begin
    MessageDlg('L''image droite n''est pas compose de pixels cods sur 8 bits ! Cration du projet impossible.', mtError, [mbOK], 0);
    ImageG.Close;
    ImageG.Free;
    ImageD.Close;
    ImageD.Free;
    Result:= false;
    Exit;
  end;
  { les tailles des images doivent tre les mmes }
  if ((ImageG.TheImage.Width <> ImageD.TheImage.Width) or (ImageG.TheImage.Height <> ImageD.TheImage.Height)) then begin
    MessageDlg('Les deux images n''ont pas les mmes dimensions ! Cration du projet impossible.', mtError, [mbOK], 0);
    ImageG.Close;
    ImageG.Free;
    ImageD.Close;
    ImageD.Free;
    Result:= false;
    Exit;
  end;
  NLig:= ImageG.TheImage.Height;
  NCol:= ImageD.TheImage.Width;
  Caption:= 'OVT [' + FNew.EditNom.Text + ']';
  ImageD.Left:= ImageD.Left + 20;
  ImageD.Top:= ImageD.Top + 20;
  DebloqueItems;
  IsProject:= true;
  { on calcule les gradients X et Y et on les garde pour toujours }
  ImGradXg:= Gradient(ImageG.TheImage, SOBELX);
  ImGradYg:= Gradient(ImageG.TheImage, SOBELY);
  ImGradXd:= Gradient(ImageD.TheImage, SOBELX);
  ImGradYd:= Gradient(ImageD.TheImage, SOBELY);
end;

function TFMain.CheckCurrentProject: Boolean;
var
  res: Integer;
begin
  { voir si pas dj un projet en cours }
  Result:= true;
  if (IsProject) then begin
    res:= MessageDlg('Vous avez un projet en cours. Voulez-vous le sauvegarder avant de quitter ?', mtWarning, [mbYes, mbNo, mbCancel], 0);
    if (res = mrCancel) then begin
      Result:= false;
      Exit;
    end
    else if (res = mrYes) then FMain.Fermerprojet1Click(nil);
    FreeProject;
  end;
end;

procedure TFMain.FormActivate(Sender: TObject);
begin
  LabelUV.Caption:= '          ';
  //if (ImageG <> nil) then
  //  if (ImageG.Visible) then ImageG.Show;
end;

procedure TFMain.Optimiserlasegmentation1Click(Sender: TObject);
begin
  FOpti.ShowModal;
end;

procedure TFMain.Rapport1Click(Sender: TObject);
begin
  FRapport.Show;
end;

procedure TFMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose:= CheckCurrentProject;
end;

procedure TFMain.Chercherlespointsdintrt1Click(Sender: TObject);
begin
  FDetect.ShowModal;
end;

procedure TFMain.SpeedButtonAddClick(Sender: TObject);
begin
  Mode:= 1; // mode cration sommets
  if (IsProject and (ImageG <> nil)) then begin
  end;
end;

procedure TFMain.SpeedButtonArrowClick(Sender: TObject);
begin
  Mode:= 0;
  if (IsProject and (ImageG <> nil)) then begin
  end;
end;

procedure TFMain.SpeedButtonMoveClick(Sender: TObject);
begin
  ImageG.Etat:= 0;
  ImageD.Etat:= 0;
  Mode:= 2; // mode dplacement sommets
end;

procedure TFMain.SpeedButtonDelClick(Sender: TObject);
begin
  Mode:= 3;
  ImageG.Etat:= 0;
  ImageD.Etat:= 0;
end;

procedure TFMain.Rinitialiserlessommetsdelimagegauche1Click(
  Sender: TObject);
var
  i: Integer;
  poly: Polygone;
begin
  if (MessageDlg('tes vous sr de vouloir supprimer tous les sommets de l''image gauche ?', mtWarning, [mbYes, mbNo], 0) = mrNo) then Exit;
  for i:= 0 to ImageG.Polygones.Count-1 do begin
    poly:= Polygone(ImageG.Polygones[i]);
    poly.Sommets.Clear;
    poly.Free;
  end;
  ImageG.Polygones.Clear;
  PtsIntDrawable:= false;
  PtsIntAppDrawable:= false;
  PtsIntAppRobDrawable:= false;
  SetLength(PtsInt, 0);
  PolygonesToMemo;
  ImageG.PaintBuffer;
  ImageG.RefreshBox;
end;

procedure TFMain.Rinitialiserlessommetsdelimagedroite1Click(
  Sender: TObject);
var
  i: Integer;
  poly: Polygone;
begin
  if (MessageDlg('tes vous sr de vouloir supprimer tous les sommets de l''image droite ?', mtWarning, [mbYes, mbNo], 0) = mrNo) then Exit;
  for i:= 0 to ImageD.Polygones.Count-1 do begin
    poly:= Polygone(ImageD.Polygones[i]);
    poly.Sommets.Clear;
    poly.Free;
  end;
  ImageD.Polygones.Clear;
  PolygonesToMemo;
  ImageD.PaintBuffer;
  ImageD.RefreshBox;
end;

procedure TFMain.Apparierlespointsdintrt1Click(Sender: TObject);
begin
  FAppariement.ShowModal;
end;

procedure TFMain.Estimerleshomographies1Click(Sender: TObject);
begin
  FEstime.ShowModal;
end;

procedure TFMain.Calculerlacartedesdisparits1Click(Sender: TObject);
begin
  FDisparites.ShowModal;
end;

procedure TFMain.Aide2Click(Sender: TObject);
begin
  FHelp.ShowModal;
end;

procedure TFMain.Button1Click(Sender: TObject);
begin
  try
    Polygone(ImageG.Polygones[StrToInt(Edit1.Text)-1]).Locked:= not Polygone(ImageG.Polygones[StrToInt(Edit1.Text)-1]).Locked;
    PolygonesToMemo;
  except
  end;
end;

procedure TFMain.Button2Click(Sender: TObject);
begin
  try
    Polygone(ImageD.Polygones[StrToInt(Edit1.Text)-1]).Locked:= not Polygone(ImageD.Polygones[StrToInt(Edit1.Text)-1]).Locked;
    PolygonesToMemo;
  except
  end;
end;

procedure TFMain.Ajusterlessommetsdevantappartenirunct1Click(
  Sender: TObject);
begin
  Mode:= 4;
  ImageG.Etat:= 0;
  ImageD.Etat:= 0;
end;

procedure TFMain.Button3Click(Sender: TObject);
var
  a: Integer;
begin
  a:= 10;
  if ((a mod 2) = 0) then
    showmessage(FloatToStr(Trunc(a/2)))
  else
    showmessage(FloatToStr(Trunc(a/2)+1))
end;

end.




