unit opti;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, StrUtils;

type
  TFOpti = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    RadioGroup1: TRadioGroup;
    Edit2: TEdit;
    Label2: TLabel;
    Edit3: TEdit;
    RadioGroup2: TRadioGroup;
    Label3: TLabel;
    Edit4: TEdit;
    GroupBox1: TGroupBox;
    Edit5: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FOpti: TFOpti;

implementation

uses
  main, fonctions, rapport;

{$R *.xfm}

procedure TFOpti.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TFOpti.Button1Click(Sender: TObject);
var
  nite, p2, i, k, n, maxiter, nsom: Integer;
  pas: Real;
  prof: array of integer;
  s: string;
  poly: Polygone;
begin
  { tester les polys }
  if ((ImageG.Polygones.Count + ImageD.Polygones.Count) = 0) then begin
    MessageDlg('Au moins un polygone est ncessaire pour cette tape.', mtError, [mbOK], 0);
    Exit;
  end;
  if ((not CheckPolys(ImageG.Polygones)) or (not CheckPolys(ImageD.Polygones))) then begin
    MessageDlg('Au moins un polygone n''est pas ferm.', mtError, [mbOK], 0);
    Exit;
  end;

  { tester les valeurs entrees }
  try
    nite:= StrToInt(Edit3.Text);
  except
    MessageDlg('Le nombre d''itrations n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    maxiter:= StrToInt(Edit5.Text);
  except
    MessageDlg('Le nombre d''itrations d''optimisation n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  try
    nsom:= StrToInt(Edit4.Text);
  except
    MessageDlg('Le nombre de sommets n''est pas une valeur correcte.', mtError, [mbOK], 0);
    Exit;
  end;
  if (RadioGroup1.ItemIndex = 0) then
    pas:= 0
  else begin
    try
      pas:= StrToFloat(Edit2.Text);
    except
      MessageDlg('Le pas n''est pas une valeur correcte.', mtError, [mbOK], 0);
      Exit;
    end;
  end;
  if (RadioGroup2.ItemIndex = 0) then
    maxiter:= 0
  else if (RadioGroup2.ItemIndex = 1) then
    nsom:= 0;

  SetLength(prof, 20);
  Edit1.Text:= Trim(Edit1.Text);
  i:= 0;
  s:= Edit1.Text;
  while (true) do begin
    p2:= Pos(' ', s);
    if (p2 = 0) then begin
      prof[i]:= StrToInt(s);
      Break;
    end;
    try
      prof[i]:= StrToInt(Copy(s, 1, p2-1));
      s:= Copy(s, p2+1, Length(s));
      Inc(i);
    except
      MessageDlg('La profondeur n''est pas une valeur correcte.', mtError, [mbOK], 0);
      Exit;
    end;
  end;
  SetLength(prof, i+1);

  FRapport.Show;
  FRapport.Write('====================================================');
  FRapport.Write('=========== Optimisation de la segmentation ==============');
  FRapport.Write('====================================================');
  s:= '  Mthode de recherche des solutions : ';
  if (MaxIter = 0) then
    s:= s + 'recherche exacte'
  else if (nsom = 0) then
    s:= s + 'recherche incomplte'
  else
    s:= s + 'recherche incomplte  partir de '+IntToStr(nsom)+' sommets';
  FRapport.Write(s);
  FRapport.Write('  Niveaux de prcision : '+Edit1.Text);
  FRapport.Write('  Nombre d''itrations par niveau de prcision : '+Edit3.Text);
  if (MaxIter <> 0) then
    FRapport.Write('  Nombre maximal d''itrations par procdure d''optimisation : '+Edit5.Text);
  s:= '  Pas d''chantillonage : ';
  if (pas = 0) then
    s:= s + 'adaptatif'
  else
    s:= s + 'forc  ' + Edit2.Text;
  FRapport.Write(s);
  FRapport.Write('');
  { pour chaque polygone de chaque image, il faut lancer l'optimisation }
  FRapport.Write('--- Image gauche ---');
  for i:= 0 to ImageG.Polygones.Count-1 do begin
    poly:= Polygone(ImageG.Polygones[i]);
    if (poly.Locked) then Continue;
    n:= 0;
    for k:= 0 to poly.Sommets.Count-1 do
      if (Sommet(poly.Sommets[k]).Bloque) then Inc(n);
    FRapport.Write('  --> Polygone '+IntToStr(i+1)+'/'+IntToStr(ImageG.Polygones.Count));
    s:= '          '+IntToStr(poly.Sommets.Count)+' sommets ('+IntToStr(n)+' bloqus) ';
    for k:= 0 to poly.Sommets.Count-1 do
      s:= s + '('+Format('%5.1f', [Sommet(poly.Sommets[k]).U]) + ' ' + Format('%5.1f', [Sommet(poly.Sommets[k]).V]) + ') ';
    FRapport.Write(s);

    { on optimise les sommets de poly }
    PolySnake2(ImGradXg, ImGradYg, poly, pas, nite, prof, nsom, maxiter);

    { on bloque les sommets de ce polygone }
    for k:= 0 to poly.Sommets.Count-1 do begin
      Sommet(poly.Sommets[k]).Bloque:= true;
    end;
  end;

  { dbloquer les sommets }
  for i:= 0 to ImageG.Polygones.Count-1 do begin
    poly:= Polygone(ImageG.Polygones[i]);
    for k:= 0 to poly.Sommets.Count-1 do begin
      Sommet(poly.Sommets[k]).Bloque:= false;
    end;
  end;

  FRapport.Write('--- Image droite ---');
  for i:= 0 to ImageD.Polygones.Count-1 do begin
    poly:= Polygone(ImageD.Polygones[i]);
    if (poly.Locked) then Continue;
    n:= 0;
    for k:= 0 to poly.Sommets.Count-1 do
      if (Sommet(poly.Sommets[k]).Bloque) then Inc(n);
    FRapport.Write('  --> Polygone '+IntToStr(i+1)+'/'+IntToStr(ImageD.Polygones.Count));
    s:= '          '+IntToStr(poly.Sommets.Count)+' sommets ('+IntToStr(n)+' bloqus) ';
    for k:= 0 to poly.Sommets.Count-1 do
      s:= s + '('+Format('%5.1f', [Sommet(poly.Sommets[k]).U]) + ' ' + Format('%5.1f', [Sommet(poly.Sommets[k]).V]) + ') ';
    FRapport.Write(s);

    { on optimise les sommets de poly }
    PolySnake2(ImGradXd, ImGradYd, poly, pas, nite, prof, nsom, maxiter);

    { on bloque les sommets de ce polygone }
    for k:= 0 to poly.Sommets.Count-1 do begin
      Sommet(poly.Sommets[k]).Bloque:= true;
    end;
  end;

  { dbloquer les sommets }
  for i:= 0 to ImageD.Polygones.Count-1 do begin
    poly:= Polygone(ImageD.Polygones[i]);
    for k:= 0 to poly.Sommets.Count-1 do begin
      Sommet(poly.Sommets[k]).Bloque:= false;
    end;
  end;

  FMain.PolygonesToMemo;
  ImageG.PaintBuffer;
  ImageG.RefreshBox;
  ImageD.PaintBuffer;
  ImageD.RefreshBox;

  //MessageDlg('L''optimisation de la segmentation est termine.', mtInformation, [mbOK], 0);
  Close;
end;

end.
