unit rapport;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls;

type
  TFRapport = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure Write(s: string);
  end;

var
  FRapport: TFRapport;

implementation

uses new, main;

{$R *.xfm}

procedure TFRapport.Write(s: string);
begin
  Memo1.Lines.Add(s);
end;

procedure TFRapport.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TFRapport.Button1Click(Sender: TObject);
var
  Save: Boolean;
begin
  Save:= true;
  SaveDialog1:= TSaveDialog.Create(Self);
  try
    {$IFDEF LINUX}
    SaveDialog1.Filter := 'Rapport obtention vrit terrain(*.txt)|*.txt';
    {$ENDIF}
    {$IFDEF MSWINDOWS}
    SaveDialog1.Filter := 'Rapport obtention vrit terrain(*.txt)';
    {$ENDIF}
    SaveDialog1.Title:= 'Sauvegarde du rapport en cours';
    SaveDialog1.InitialDir:= LastDir;
    SaveDialog1.FileName:= FNew.EditNom.Text + '.txt';
    if (SaveDialog1.Execute) Then begin
      // check si le fichier existe
      if (FileExists(SaveDialog1.FileName)) then begin
        if (MessageDlg('Ce fichier de projet existe dj. Voulez-vous le remplacer ?', mtWarning, [mbYes, mbNo], 0) = mrNo) then Save:= false;
      end;
      if (Save) then begin
        if (pos('.txt',SaveDialog1.FileName) = 0) Then SaveDialog1.FileName:= SaveDialog1.FileName + '.txt';
        LastDir:= ExtractFileDir(SaveDialog1.FileName);
        Memo1.Lines.SaveToFile(SaveDialog1.FileName);
      end
    end;
  finally
    SaveDialog1.Free;
  end;
end;

end.
