unit zoom;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QExtCtrls, image;

type
  TFZoom = class(TForm)
    PaintBox: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PaintBoxPaint(Sender: TObject);
  private
    { Dclarations prives }
    TheBuffer: TBitmap;
    procedure RefreshBox;
  public
    { Dclarations publiques }
    ImagesLoaded: Boolean;
    procedure PaintBuffer(Image: TFImage; X, Y: Integer);
  end;

var
  FZoom: TFZoom;

implementation

uses
  main;

{$R *.xfm}

procedure TFZoom.FormCreate(Sender: TObject);
begin
  ImagesLoaded:= false;
  TheBuffer:= TBitmap.Create;
  TheBuffer.Width:= 1024;
  TheBuffer.Height:= 1024;
end;

procedure TFZoom.FormDestroy(Sender: TObject);
begin
  TheBuffer.Free;
end;

procedure TFZoom.PaintBuffer(Image: TFImage; X, Y: Integer);
var
//  Image: TFImage;
  X0, Y0, W2, H2: Integer;
begin
//  if (ImageG.Active) then Image:= ImageG
//  else if ImageD.Active then Image:= ImageD
//  else Exit;
  W2:= Round(Width/2);
  H2:= Round(Height/2);
  if ((X - W2) < 0) then X0:= 0
  else if ((X + W2) > Image.TheImage.Width) then X0:= Image.TheImage.Width - FZoom.Width
  else X0:= X - W2;
  TheBuffer.Canvas.CopyRect(Rect(0, 0, Width, Height), Image.TheImage.Canvas, Rect(X0, 0, Width, Height));
end;

procedure TFZoom.RefreshBox;
begin
  PaintBox.Canvas.CopyRect(Rect(0, 0, Width, Height), TheBuffer.Canvas, Rect(0, 0, Width, Height));
end;

procedure TFZoom.PaintBoxPaint(Sender: TObject);
begin
  if (ImagesLoaded) then begin
    //PaintBuffer;
    RefreshBox;
  end;
end;

end.
